<template>
    <div
        v-if="data"
        class="page-container"
    >
        <div
            v-if="shop"
            class="row mb-15"
        >
            <div
                v-for="statsObject in statsObjects"
                class="col-lg-4 col-xl-2"
            >
                <div class="panel panel-default">
                    <div class="panel-heading text-center">
                        {{ statsObject.title }}
                    </div>
                    <div class="panel-body text-center">
                        <template v-if="data[statsObject.value] || data[statsObject.value] === 0">
                            <span
                                v-if="statsObject.value === 'totalCVR'"
                                class="number"
                            >
                                {{ data[statsObject.value] ? parseFloat(data[statsObject.value]).toFixed(2) + '%' : 0 }}
                            </span>
                            <span
                                v-else-if="statsObject.value === 'totalRevenue'"
                                class="number"
                            >
                                {{ data[statsObject.value] }}{{ getCurrencySign.symbol_native }}
                            </span>
                            <span
                                v-else
                                class="number"
                            >
                                {{ data[statsObject.value] }}
                            </span>
                            <span class="subtitle">{{ statsObject.subTitle }}</span>
                        </template>

                        <div
                            v-else
                            class="text-center"
                        >
                            <b-spinner
                                variant="primary"
                                label="Spinning"
                            />
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div v-if="data.popups.length >= 1">
            <GrowthTable
                :data="data"
                @freshData="freshData"
            />
        </div>
        <div
            v-if="data.popups.length < 1"
            class="add-reminder-container"
        >
            <div>
                <b-btn
                    class="btn blue-btn"
                    @click="addPopup"
                >
                    Add Pop Up
                </b-btn>
            </div>
        </div>
    </div>
</template>

<script>
import VideoButton from '../../components/header/VideoButton';
import DateRangePicker from "vue2-daterange-picker";
import 'vue2-daterange-picker/dist/vue2-daterange-picker.css';
import GrowthCart from "../../components/growth-tools/GrowthCart";
import GrowthTable from "../../components/growth-tools/GrowthTable";
import headers from '../../helpers/authHeader';
import link from '../../helpers/backLink'
import currencies from "../../data/currencies.json";
import shop from '../../mixins/shop.service';

export default {
    name: "Index",
    components: {GrowthTable, GrowthCart, VideoButton, DateRangePicker},
    mixins: [headers, link, shop],
    data() {
        let date = new Date()
        return {
            shop: null,
            currencies: currencies,
            data: {
                popups: [],
                total_impressions: '',
                total_subscribers: '',
                conversion_rate: '',
                channels_per_subscribers: '',
                total_subscriptions: '',
                revenue: ''
            },
            statsObjects: [
                {title: 'Total Impressions', value: 'totalImpressions', subTitle: 'Quantity'},
                {title: 'Total Subscribers', value: 'totalSubscribers', subTitle: 'Quantity'},
                {title: 'Conversion Rate', value: 'totalCVR', subTitle: ''},
                {title: 'Channels Per Subscribers', value: 'totalPerChannel', subTitle: 'Average'},
                {title: 'Total Subscriptions', value: 'totalSubscription', subTitle: ''},
                {title: 'Revenue', value: 'totalRevenue', subTitle: ''},
            ],
            helpModalId: 'HelpModalEmailAdandonedCarts',
            dateRange: {
                startDate: this.$formatter.dateFormat(date.setDate(date.getDate() - 30), 'DD MMMM YYYY'),
                endDate: this.$formatter.dateFormat(new Date(), 'DD MMMM YYYY'),
            },
        }
    },
    computed: {
        getCurrencySign() {
            if (!this.currencies)
                return {
                    symbol: this.shop.payment_currency
                };
            return this.currencies[this.shop.payment_currency];
        }
    },
    mounted() {
        this.freshData()
    },
    created() {
        this.loadShop()
    },
    methods: {
        async loadShop() {
            this.shop = await this.getShop()
        },
        freshData() {
            axios.get(`${this.getSegment()}/growth`, this.getUserHeader())
                .then(response => {
                    this.data = response.data;
                    this.loading = false;
                });
        },
        addPopup() {
            axios.post(`${this.getSegment()}/growth/`, {}, this.getUserHeader())
                .then(response => {
                    if (response && response.hasOwnProperty('data')) {

                        this.$notify({
                            type: 'success',
                            title: 'Created'
                        });

                        this.$router.push(`/growth-tools-edit/${response.data.id}`)
                    }
                });
        },
    }
}
</script>

<style scoped lang="scss">

.panel-heading {
    //padding: 15px 0 !important;
    height: 60px !important;
    display: flex;
    justify-content: center;
    align-items: center;
   // white-space: nowrap;
   // font-size: 12px;

}

.carts-container {
    margin-top: 20px;
}

.panel-default .panel-heading {
    background: #ffffff;
}

.panel .panel-heading {
    position: relative;
    border-color: #DFE6F2;
    font-weight: 500;
}

.panel-heading {
    padding: 10px 15px;
    border-bottom: 1px solid transparent;
    border-top-left-radius: 3px;
    border-top-right-radius: 3px;
}

.panel .panel-body {
    padding: 20px;
}

.panel .panel-body .number {
    font-size: 24px;
    font-weight: 900;
    color: #4786FF;
}

.panel-default {
    margin-top: 20px;
    min-height: 148px;
}

.panel .panel-body .subtitle {
    display: block;
    color: #A8B2C4;
    font-size: 12px;
    min-height: 50px;
}

.panel-default > .panel-heading {
    color: #333;
}

.calendar-container {
    margin-top: 40px;
    display: flex;
    justify-content: flex-end;
    align-items: center;
}


</style>
